/*

  Copyright (C) 1999-2005 by Alexander Tenbusch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License 
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>

#include <assert.h>
#include <limits.h>

#include <libxml/parser.h>
#include <libxml/tree.h>

#include "tools.h"
#include "mem.h"
#include "petrinet.h"
#include "graph.h"
#include "web.h"

#if 0
char *version_str = "Plain Petrinet v2.2 (p) 2004,2005 A. Tenbusch";

char *version_url = "http://pkg.tenbusch.info/documentation/";
#endif

int
main(int argc, char **argv) {

  petrinet_t *pn;
  index_t i_s;

  char *filename_cfg_xml;

  xmlDoc *xml;
  xmlNode *root_element;

  char buffer[BUFFER_LENGTH];

  /****************************************************

   Options

  */

  printf_debug("Run in command line mode");

  filename_cfg_xml = argv[1];

  /****************************************************

   !!! Construction area !!!

  */

  LIBXML_TEST_VERSION

  mem_init();			/* initialize my memory manager */

  pn = petrinet_new(filename_cfg_xml,command_line);

#if 0

  petrinet_set_start(pn,"anschau_modell");
  petrinet_set_target(pn,"nullserien_modell");
  pn->t[16].valid = false;

  petrinet_set_start(pn,"s1");
  petrinet_set_target(pn,"s9");
  pn->t[state_index4id(pn,"s8")].valid = false;

  petrinet_all_out_flag(pn,true);
  petrinet_pathnet_out_flag(pn,true);
#endif

  /****************************************************

   Processing

  */

  web_header(stdout,pn);
  web_subnets_list(stdout,pn);
  web_footer(stdout,pn);

#if 0
  for (i_s=0; i_s < pn->n_sn; i_s++) {
    printf("\t%s\n", pn->sn[i_s].id);
    graph_subnet(stdout,pn,pn->sn,0,empty_str);
  }

  web_header(stdout,pn,empty_str);
  web_navigation(stdout,pn,empty_str,"ppp","xxx.xml");
  web_footer(stdout);
#endif

#if 0
  graph_header(stdout, pn);
  graph_pathnet(stdout, pn, empty_str);
  graph_footer(stdout);
#endif

  /****************************************************

   !!! Destruction area !!!

  */

  petrinet_free(pn);

  xmlCleanupParser();

  exit(EXIT_SUCCESS);

  return EXIT_SUCCESS;		/* dummy only */
}

