/*

  Copyright (C) 1999-2005 by Alexander Tenbusch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License 
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* extern const char *empty_str; */
extern xmlChar *empty_str;

#define BUFFER_LENGTH 1024


/* 
   header for mem.c

*/

extern void 
mem_init( void );

extern void **
mem_alloc_2d(const size_t nxmemb, const size_t nymemb, const size_t size);

extern void 
mem_free_2d(void **ptr);

extern void 
mem_unregister(void *ptr);

extern flag_t 
mem_valid(void *ptr);


#ifdef MDEBUG

extern void *
mem_ialloc( char *file, int line, size_t nmemb, size_t size);

extern void *
mem_iregister( char *file, int line, void *ptr, 
			    size_t nmemb, size_t size);

extern void 
mem_info(void);

extern void 
mem_ifree(char *file, const unsigned int line, const void *ptr);

#define mem_alloc(N,S) mem_ialloc(__FILE__,__LINE__,N,S)

#define mem_free(P) mem_ifree(__FILE__,__LINE__,P)

#define mem_register(P,N,S) mem_iregister(__FILE__,__LINE__,P,N,S)

#define exit(N) { \
  fprintf( stderr, "\nexit(%i) at " __FILE__ ":%i\n", N, __LINE__ ); \
  exit(N); \
}

#else 

extern void *
mem_alloc( size_t nmemb, size_t size);

extern void *
mem_register( void *ptr, size_t nmemb, size_t size );

extern void 
mem_free(void *ptr);

#define mem_info()

#endif


