/*

  Copyright (C) 1999-2005 by Alexander Tenbusch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License 
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/* 
   common header

*/

/*--------------------------------------------------------------------

  numerischer Typ 'index_t'

*/

typedef int index_t;


typedef enum {
  false,
  true
} flag_t;


typedef enum {
  cgi,
  command_line
} run_t;


/****************************************************************************

  type definition: htitem_t
*/

typedef struct _htitem htitem_t;
struct _htitem {

  /* 

  */

  xmlChar *id;			/*!< id of subnet */

  xmlChar *text;

  xmlChar *href;

/*   struct _htitem *next; */

};

#define ERROR_INDEX -1

#define BUFFER_LENGTH 1024

/* extern const char *empty_str; */
extern xmlChar *empty_str;

/****************************************************************************

   Declaration of public functions (prototypes)
*/

extern index_t 
number_of(xmlNode * a_node, const xmlChar *element_name, index_t n);

extern xmlNode * 
child_element(xmlNode * a_node, const xmlChar *element_name);

extern xmlChar * 
child_content(xmlNode * a_node);

extern xmlChar * 
attribute_str(xmlNode * a_node, const xmlChar *attribute_name);

extern unsigned char * 
isolat1_str(unsigned char *b, xmlChar *a, size_t n_max);

htitem_t *
htlist_new(xmlNode * a_node, const xmlChar *tag);

extern void
printf_exit(flag_t flag, int exit_code, char *fmt, ...);

extern void
printf_debug(char *fmt, ...);

extern char *
sprintpath(char *buffer, ...);
